// background.js
console.log('我是后台js...');
//
function util_isnumber(val){
    var regPos = /^[0-9]+.?[0-9]*/; //判断是否是数字。
    if(regPos.test(val) ){
        return true;
    }else{
        return false;
    }
}

function extractEmails (text) {
    return text.match(/([a-zA-Z0-9._-]+@[a-zA-Z0-9._-]+\.[a-zA-Z0-9._-]+)/gi);
}

function util_url_get_domain(url=''){
    url = url.replace('https://','');
    url = url.replace('http://','');
    url = url.replace('www.','');
    urlArr = url.split('/');
    if(urlArr.length>0){
        return urlArr[0];
    }
    return '';
}

function util_url_get_domain_host(url=''){
    domain = util_url_get_domain(url);
    if(domain){
        domainArr = domain.split('.');
        if(domainArr.length>1){
           var domain_may = domainArr[1];
           if(domain_may.length>=5){
               return domain_may;
           }else{
               return domainArr[0];
           }
        }else if(domainArr.length==1){
            return domainArr[0];
        }
    }
    return '';
}

function util_domains_set_from_html(domain_id, html_data='',
                                    q=1, need_urls=[],
                                    is_check_domain_yizhi=true){
    console.log('util_domains_set_from_html');
    //console.log(html_data);
    var emails = [];
    if(html_data){
        var forbidden_keys = ['1.8.1','.cart', '.index', '.collection',
            '.js', 'template.404','tel:', 'mailto:', '.jpg', '.pdf', '.doc',
            '.xls', '.xlsx', '.png', '.jpeg', '.webp', '.gif', 'javascript:',
            'skype', '#', 'None', '.svg', 'desktop.ts', 'example', 'css', '.studio', 'image', 'jquery', 'swiper', 'myshopline.com',
            'img_', 'xxx.xxx', 'foundation-sites', 'exemple@mail.com', 'exemple@gmail.be', 'exemple@mail.ch', 'john@email.com',
            'your.email@address.com', 'stores@domain.com', 'test@email.com', 'first.last@company.com', 'you@email.com', 'your-email@shopify.com',
            'ada@ada.lt', 'johndoe@domain.com', 'your@email.com', 'jane.smith@email.com', 'abc@xyz.com', 'user@domain.com', 'template.account@template.blog',
            'john@test.com', 'emily@test.com', 'email@domain.com', 'yourname@email.com', 'jill@mail.com', 'joebloggs@email.com', 'abc@abc.abc', 'support@domain.com', 'yellow@hello.com'];
        emails = extractEmails(html_data);
        console.log(emails);
    }

    domains_get(function (callback_data) {
        domains = callback_data['domains'];
        //
        var domain_emails = [];
        if(emails && emails.length>0){
            for(j=0;j<emails.length;j++){
                var current_email = emails[j];
                current_email = current_email.toLowerCase().trim();
                //把字符串最后一个.移除掉
                if(current_email[current_email.length-1] == '.'){
                    current_email = current_email.slice(0,-1);
                }
                //排除有些如 .png
                var is_forbidden = false;
                for(k=0;k<forbidden_keys.length;k++){
                    if(current_email.indexOf(forbidden_keys[k])!=-1){
                        is_forbidden = true;
                        break;
                    }
                }
                //leaflet@1.8.0
                let current_email_arr = current_email.split('@');
                if(current_email_arr.length > 1){
                    let current_a_houzhui = current_email_arr[1];
                    let current_a_houzhui_arr = current_a_houzhui.split('.');
                    let is_num_shuliang = 0;
                    for(let k=0;k<current_a_houzhui_arr.length;k++){
                        if(util_isnumber(current_a_houzhui_arr[k])){
                            is_num_shuliang +=1;
                        }
                    }
                    if(is_num_shuliang >=2){
                        is_forbidden = true;
                    }
                }
                //
                if(is_check_domain_yizhi){
                    console.log('is_check_domain_yizhi');
                    let _domain = domains[domain_id]['d'];
                    _domain = _domain.replace('https://', '');
                    _domain = _domain.replace('http://', '');
                    _domain = _domain.replace('www.', '');
                    console.log('_domain:'+_domain);
                    let current_email_arr = current_email.split('@');
                    console.log('current_email_arr:'+current_email_arr);
                    if(current_email_arr.length > 1 && _domain != current_email_arr[1]){
                        is_forbidden = true;
                    }
                }
                //
                //
                if(!is_forbidden && !domain_emails.includes(current_email)){
                    domain_emails.push(current_email);
                }
                //
            }
        }
        domain_email_set(domains[domain_id]['d'], q, domain_emails, function (){
            if(need_urls.length>0){
                let _q = 2;
                for(v=0;v<need_urls.length;v++){
                    //yandex不能使用fetch，会301
                    if(need_urls[v].indexOf('yandex') != -1){
                        spider_ajax_request(domain_id, need_urls[v], _q);
                    }else{
                        spider_request_fetch(domain_id, need_urls[v], _q);
                    }
                    _q++;
                }
            }
        });
        //
    });
    console.log('util_domains_set_from_html end');
}

function spider_domain(domain_id, url){
    console.log('spider domain:'+url);
    $.ajax({
        url:url,
        data: {},
        type: 'GET',
        async:true,
        dataType: 'html',
        contentType:'text/html; charset=utf-8',
        crossDomain: true,
        cache: false,
        success: function(data) {
            console.log('spider_ajax_request_homepage complete');
            if(data){
                //
                    var $html = $(data);
                    //针对单个url可货站的urls搜索
                    //index、contact、about、privacy,policy,terms,conditions,faq,return,refund,shipping,whatsapp
                    //https://www.bing.com/search?q=inbody%3A%40donmily.com&ensearch=1
                    //https://cn.bing.com/search?q=inbody%3A%40donmily.com&ensearch=1
                    //http://124.71.24.32:3039/api/center/plugin/email/database/query?emailDomain=unice.com
                    //https://www.google.com.jm/search?q=intext%3A%40unice.com
                    //https://www.google.co.in/search?q=intext%3A%40costway.com#ip=1
                    //
                    var url_domain = util_url_get_domain(url);
                    var need_urls = [];
                    var need_cha_urls = ['contact', 'about', 'privacy',
                        'policy', 'terms', 'conditions', 'faq', 'return',
                        'refund', 'shipping', 'whatsapp', 'safety', 'quality',
                        'guide', 'service', 'affiliate', 'shippment', 'brand',
                        'followus'];
                    var domain_host = util_url_get_domain_host(url);
                    $html.find('a').each(function (){
                        var temp_href = $(this).attr('href');
                        if(typeof temp_href !== 'undefined'){
                            if(temp_href.indexOf('http')==-1){
                                if(temp_href.indexOf('/')!=-1){
                                    temp_href = url+temp_href;
                                }else{
                                    temp_href = url+'/'+temp_href;
                                }
                            }
                            for(i=0; i<need_cha_urls.length;i++){
                                if(temp_href.indexOf(need_cha_urls[i])!=-1 && temp_href.indexOf(domain_host)!=-1){
                                    if(!need_urls.includes(temp_href)){
                                        need_urls.push(temp_href);
                                    }
                                }
                            }
                        }
                        //
                    });
                    var googles_url = [
                        'https://www.google.com/', //美国
                        'https://www.google.ca/', //加拿大
                        'https://www.google.cd/', //民主刚果
                        'https://www.google.cg/', //刚果
                        'https://www.google.ch/', //瑞士
                        'https://www.google.ci/', //Cote D’Ivoire
                        'https://www.google.co.ck/', //库克
                        'https://www.google.cl/', //智利
                        'https://www.google.com.co/', //哥伦比
                        'https://www.google.co.cr/', //哥斯达尼加
                        'https://www.google.com.cu/', //古
                        'https://www.google.cz/', //捷克
                        'https://www.google.de/', //德国
                        'https://www.google.dj/', //吉布提
                        'https://www.google.dk/', //丹麦
                        'https://www.google.dm/', //多米尼加联邦
                        'https://www.google.com.do/', //多米尼加共和
                        'https://www.google.com.ec/', //厄瓜多
                        'https://www.google.ee/', //爱沙尼亚
                        'https://www.google.com.eg/', //埃
                        'https://www.google.es/', //西班牙
                        'https://www.google.com.et/', //埃塞俄比
                        'https://www.google.com.fj/', //斐
                        'https://www.google.fm/', //密克罗尼西亚
                        'https://www.google.fr/', //法国
                        'https://www.google.ge/', //格鲁吉亚
                        'https://www.google.gg/', //Guernsey
                        'https://www.google.com.gi/', //Gibraltar
                        'https://www.google.gl/', //格陵兰
                        'https://www.google.gm/',//冈比亚
                        'https://www.google.gp/', //爪德罗普岛
                        'https://www.google.gr/', //希腊
                        'https://www.google.com.gt/', //危地马
                        'https://www.google.gy/', //圭亚那
                        'https://www.google.com.hk/', //香港
                        'https://www.google.hr/', //克罗地亚
                        'https://www.google.ht/', //海地
                        'https://www.google.hu/', //匈牙利
                        'https://www.google.co.id/', //印度尼西亚
                        'https://www.google.ie/', //爱尔兰
                        'https://www.google.co.il/', //以色列
                        'https://www.google.im/', //马恩岛
                        'https://www.google.co.in/', //印度
                        'https://www.google.is/', //冰岛
                        'https://www.google.it/', //意大利
                        'https://www.google.je/', //泽西岛
                        'https://www.google.com.jm/', //牙买
                        'https://www.google.jo/', //约旦
                        'https://www.google.co.jp/', //日本
                        'https://www.google.co.ke/', //肯尼亚
                        'https://www.google.com.kh/', //柬埔
                        'https://www.google.ki/', //基里巴斯
                        'https://www.google.kg/', //吉尔吉斯斯坦
                        'https://www.google.co.kr/', //韩国
                        'https://www.google.kz/', //哈萨克斯坦
                        'https://www.google.la/', //老挝
                        'https://www.google.li/', //列支敦士登
                        'https://www.google.lk/', //斯里兰卡
                        'https://www.google.co.ls/', //莱索托
                        'https://www.google.lt/', //立陶宛
                        'https://www.google.lu/', //卢森堡
                        'https://www.google.lv/', //拉托维亚
                        'https://www.google.com.ly/', //利比
                        'https://www.google.co.ma/', //摩洛哥
                        'https://www.google.md/', //摩尔多瓦
                        'https://www.google.mn/', //蒙古
                        'https://www.google.ms/', //蒙特塞拉特
                        'https://www.google.com.mt/', //马耳
                        'https://www.google.mu/', //毛里求斯
                        'https://www.google.mv/', //马尔代夫
                        'https://www.google.mw/', //马拉维
                        'https://www.google.com.mx/', //墨西
                        'https://www.google.com.na/', //纳米比
                        'https://www.google.com.nf/', //诺夫克
                        'https://www.google.com.ng/', //尼日尼
                        'https://www.google.com.ni/', //尼加拉
                        'https://www.google.nl/', //荷兰
                        'https://www.google.no/', //挪威
                        'https://www.google.com.np/', //尼泊
                        'https://www.google.nr/', //瑙鲁
                        'https://www.google.nu/', //纽埃岛
                        'https://www.google.co.nz/', //新西兰
                        'https://www.google.com.om/', //阿
                        'https://www.google.com.pa/', //巴拿
                        'https://www.google.com.pe/', //秘
                        'https://www.google.com.ph/', //菲律
                        'https://www.google.com.pk/', //巴基斯
                        'https://www.google.pl/',//波兰
                        'https://www.google.pn/', //皮特克恩岛
                        'https://www.google.com.pr/',//波多黎
                        'https://www.google.pt/', //葡萄牙
                        'https://www.google.com.py/', //巴拉
                        'https://www.google.com.qa/', //卡塔
                        'https://www.google.ro/', //罗马尼亚
                        'https://www.google.ru/', //俄罗斯
                        'https://www.google.rw/', //卢旺达
                        'https://www.google.com.sa/', //沙,
                        'https://www.google.com.sb/', //所罗
                        'https://www.google.sc/', //塞舌尔
                        'https://www.google.se/', //瑞典
                        'https://www.google.com.sg/', //新加
                        'https://www.google.sh/', //圣赫勒拿岛
                        'https://www.google.si/', //斯洛文尼亚
                        'https://www.google.sk/', //斯洛伐克
                        'https://www.google.sn/', //塞内加尔
                        'https://www.google.sm/', //圣马力诺
                        'https://www.google.st/', //圣多美和普林西比
                        'https://www.google.com.sv/', //萨尔瓦
                        'https://www.google.co.th/', //泰国
                        'https://www.google.com.tj/', //塔吉克斯
                        'https://www.google.tk/', //托克劳
                        'https://www.google.tm/', //土库曼
                        'https://www.google.to/', //汤加
                        'https://www.google.tp/', //东帝汶
                        'https://www.google.com.tr/', //土耳
                        'https://www.google.tt/', //特立尼和多巴哥
                        'https://www.google.com.tw/', //台
                        'https://www.google.com.ua/', //乌克
                        'https://www.google.co.ug/', //乌干达
                        'https://www.google.co.uk/', //英国
                        'https://www.google.com.uy/', //乌拉
                        'https://www.google.co.uz/', //Uzbekistan
                        'https://www.google.com.vc/', //圣文森特和格林纳丁
                        'https://www.google.co.ve/', //委内瑞拉
                        'https://www.google.vg/', //维京岛
                        'https://www.google.co.vi/', //维尔京群岛
                        'https://www.google.com.vn/', //越南
                        'https://www.google.vu/', //瓦努尔图
                        'https://www.google.ws/', //西萨摩亚
                        //'https://www.google.co.yu/', //南斯拉夫
                        'https://www.google.co.za/', //南非
                        'https://www.google.co.zm/', //赞比亚
                        'https://www.google.co.zw/', //津巴布韦
                    ];
                    //随机从数组中获取一个值
                    var google_url = googles_url[Math.floor((Math.random()*googles_url.length))];
                    need_urls.push(google_url+'search?q='+url_domain+'+email+OR+E-mail+OR+mail+OR+maito+OR+contact+-inurl:(zoominfo|dnb|rocketreach|signalhire|easyleadz|contactout|apollo|verifier|getemail|aeroleads|datanyze)&ie=utf-8&&num=50&oe=utf-8');
                    //
                     need_urls.push('https://search.yahoo.com/search?p=intext:'+url_domain+'&fr2=sb-top&fr=yfp-t&fp=1');
                    //
                    need_urls.push('https://search.aol.com/aol/search?q=intext:'+url_domain+'&s_it=sb-top&v_t=na');
                    //
                    need_urls.push('https://yandex.com/search/?text='+url_domain+'+email&lr=109371');
                    var tq = need_urls.length+1;
                    domain_tq_set(url, tq, function (){
                    //
                        util_domains_set_from_html(domain_id, data, 1, need_urls, false);
                    //
                    });
            }else{
                //
                domain_tq_set(url, 1, function (){
                    //
                    util_domains_set_from_html(domain_id, '', 1);
                    //
                });
                //
            }
        },
        error: function( jqXHR, textStatus, errorThrown ) {
            console.log( 'spider_domain error:'+jqXHR, textStatus, errorThrown );
            //对于访问异常的请求,直接过滤
            //
            domain_tq_set(url, 1, function (){
                util_domains_set_from_html(domain_id, '', 1);
            });
            //
        }
    });
}

function spider_ajax_request(domain_id, url, q){
    console.log('spider_ajax_request:'+url);
    //
    $.ajax({
        url:url,
        data: {},
        type: 'GET',
        async:true,
        dataType: 'html',
        contentType:'text/html; charset=utf-8',
        crossDomain: true,
        cache: false,
        success: function(data) {
            console.log('url:'+url+' success');
            console.log('util_domains_set_from_html');
            util_domains_set_from_html(domain_id, data, q);
            console.log('url:'+url+' end');
        },
       error: function( jqXHR, textStatus, errorThrown ) {
            console.log( jqXHR, textStatus, errorThrown );
            //对于访问异常的请求,直接过滤
            util_domains_set_from_html(domain_id, '', q);
        }
    });
}

//返回html
async function fetch_request(url){
     var return_html = '';
     let options = {
         method: 'get',
         headers: {
             'Content-Type':'application/json;charset=utf-8'
         },
         // body: JSON.stringify(res)
     }
     // Fake api for making post requests
    //console.log('fetch_request url:'+url);
    await fetch(url,options)
        .then(res => res.text())
        .then(d => {
            //403错误也是直接到这里了
            console.log('post response:');
            //console.log(d);
            return_html = d;
        }).catch(function (){
            console.log('fetch_request error url:'+url);
            return_html = '';
        })
    return return_html;
}

function spider_domain_fetch(domain_id, url){
    console.log('spider_domain_fetch domain:'+url);
    //
    let return_html = fetch_request(url);
    return_html.then((data) => {
        if(data){
            //
            var $html = $(data);
            //针对单个url可货站的urls搜索
            //index、contact、about、privacy,policy,terms,conditions,faq,return,refund,shipping,whatsapp
            //https://www.bing.com/search?q=inbody%3A%40donmily.com&ensearch=1
            //https://cn.bing.com/search?q=inbody%3A%40donmily.com&ensearch=1
            //http://124.71.24.32:3039/api/center/plugin/email/database/query?emailDomain=unice.com
            //https://www.google.com.jm/search?q=intext%3A%40unice.com
            //https://www.google.co.in/search?q=intext%3A%40costway.com#ip=1
            //
            var url_domain = util_url_get_domain(url);
            var need_urls = [];
            var need_cha_urls = ['contact', 'about', 'privacy',
                        'policy', 'terms', 'conditions', 'faq', 'return',
                        'refund', 'shipping', 'whatsapp', 'safety', 'quality',
                        'guide', 'service', 'affiliate', 'shippment', 'brand',
                        'followus'];
            var domain_host = util_url_get_domain_host(url);
            $html.find('a').each(function (){
                var temp_href = $(this).attr('href');
                if(typeof temp_href !== 'undefined'){
                    if(temp_href.indexOf('http')==-1){
                        if(temp_href.indexOf('/')!=-1){
                            temp_href = url+temp_href;
                        }else{
                                   temp_href = url+'/'+temp_href;
                        }
                    }
                    for(i=0; i<need_cha_urls.length;i++){
                        if(temp_href.indexOf(need_cha_urls[i])!=-1 && temp_href.indexOf(domain_host)!=-1){
                            if(!need_urls.includes(temp_href)){
                                need_urls.push(temp_href);
                            }
                        }
                    }
                }
            });
            var googles_url = [
                        'https://www.google.com/', //美国
                        'https://www.google.ca/', //加拿大
                        'https://www.google.cd/', //民主刚果
                        'https://www.google.cg/', //刚果
                        'https://www.google.ch/', //瑞士
                        'https://www.google.ci/', //Cote D’Ivoire
                        'https://www.google.co.ck/', //库克
                        'https://www.google.cl/', //智利
                        'https://www.google.com.co/', //哥伦比
                        'https://www.google.co.cr/', //哥斯达尼加
                        'https://www.google.com.cu/', //古
                        'https://www.google.cz/', //捷克
                        'https://www.google.de/', //德国
                        'https://www.google.dj/', //吉布提
                        'https://www.google.dk/', //丹麦
                        'https://www.google.dm/', //多米尼加联邦
                        'https://www.google.com.do/', //多米尼加共和
                        'https://www.google.com.ec/', //厄瓜多
                        'https://www.google.ee/', //爱沙尼亚
                        'https://www.google.com.eg/', //埃
                        'https://www.google.es/', //西班牙
                        'https://www.google.com.et/', //埃塞俄比
                        'https://www.google.com.fj/', //斐
                        'https://www.google.fm/', //密克罗尼西亚
                        'https://www.google.fr/', //法国
                        'https://www.google.ge/', //格鲁吉亚
                        'https://www.google.gg/', //Guernsey
                        'https://www.google.com.gi/', //Gibraltar
                        'https://www.google.gl/', //格陵兰
                        'https://www.google.gm/',//冈比亚
                        'https://www.google.gp/', //爪德罗普岛
                        'https://www.google.gr/', //希腊
                        'https://www.google.com.gt/', //危地马
                        'https://www.google.gy/', //圭亚那
                        'https://www.google.com.hk/', //香港
                        'https://www.google.hr/', //克罗地亚
                        'https://www.google.ht/', //海地
                        'https://www.google.hu/', //匈牙利
                        'https://www.google.co.id/', //印度尼西亚
                        'https://www.google.ie/', //爱尔兰
                        'https://www.google.co.il/', //以色列
                        'https://www.google.im/', //马恩岛
                        'https://www.google.co.in/', //印度
                        'https://www.google.is/', //冰岛
                        'https://www.google.it/', //意大利
                        'https://www.google.je/', //泽西岛
                        'https://www.google.com.jm/', //牙买
                        'https://www.google.jo/', //约旦
                        'https://www.google.co.jp/', //日本
                        'https://www.google.co.ke/', //肯尼亚
                        'https://www.google.com.kh/', //柬埔
                        'https://www.google.ki/', //基里巴斯
                        'https://www.google.kg/', //吉尔吉斯斯坦
                        'https://www.google.co.kr/', //韩国
                        'https://www.google.kz/', //哈萨克斯坦
                        'https://www.google.la/', //老挝
                        'https://www.google.li/', //列支敦士登
                        'https://www.google.lk/', //斯里兰卡
                        'https://www.google.co.ls/', //莱索托
                        'https://www.google.lt/', //立陶宛
                        'https://www.google.lu/', //卢森堡
                        'https://www.google.lv/', //拉托维亚
                        'https://www.google.com.ly/', //利比
                        'https://www.google.co.ma/', //摩洛哥
                        'https://www.google.md/', //摩尔多瓦
                        'https://www.google.mn/', //蒙古
                        'https://www.google.ms/', //蒙特塞拉特
                        'https://www.google.com.mt/', //马耳
                        'https://www.google.mu/', //毛里求斯
                        'https://www.google.mv/', //马尔代夫
                        'https://www.google.mw/', //马拉维
                        'https://www.google.com.mx/', //墨西
                        'https://www.google.com.na/', //纳米比
                        'https://www.google.com.nf/', //诺夫克
                        'https://www.google.com.ng/', //尼日尼
                        'https://www.google.com.ni/', //尼加拉
                        'https://www.google.nl/', //荷兰
                        'https://www.google.no/', //挪威
                        'https://www.google.com.np/', //尼泊
                        'https://www.google.nr/', //瑙鲁
                        'https://www.google.nu/', //纽埃岛
                        'https://www.google.co.nz/', //新西兰
                        'https://www.google.com.om/', //阿
                        'https://www.google.com.pa/', //巴拿
                        'https://www.google.com.pe/', //秘
                        'https://www.google.com.ph/', //菲律
                        'https://www.google.com.pk/', //巴基斯
                        'https://www.google.pl/',//波兰
                        'https://www.google.pn/', //皮特克恩岛
                        'https://www.google.com.pr/',//波多黎
                        'https://www.google.pt/', //葡萄牙
                        'https://www.google.com.py/', //巴拉
                        'https://www.google.com.qa/', //卡塔
                        'https://www.google.ro/', //罗马尼亚
                        'https://www.google.ru/', //俄罗斯
                        'https://www.google.rw/', //卢旺达
                        'https://www.google.com.sa/', //沙,
                        'https://www.google.com.sb/', //所罗
                        'https://www.google.sc/', //塞舌尔
                        'https://www.google.se/', //瑞典
                        'https://www.google.com.sg/', //新加
                        'https://www.google.sh/', //圣赫勒拿岛
                        'https://www.google.si/', //斯洛文尼亚
                        'https://www.google.sk/', //斯洛伐克
                        'https://www.google.sn/', //塞内加尔
                        'https://www.google.sm/', //圣马力诺
                        'https://www.google.st/', //圣多美和普林西比
                        'https://www.google.com.sv/', //萨尔瓦
                        'https://www.google.co.th/', //泰国
                        'https://www.google.com.tj/', //塔吉克斯
                        'https://www.google.tk/', //托克劳
                        'https://www.google.tm/', //土库曼
                        'https://www.google.to/', //汤加
                        'https://www.google.tp/', //东帝汶
                        'https://www.google.com.tr/', //土耳
                        'https://www.google.tt/', //特立尼和多巴哥
                        'https://www.google.com.tw/', //台
                        'https://www.google.com.ua/', //乌克
                        'https://www.google.co.ug/', //乌干达
                        'https://www.google.co.uk/', //英国
                        'https://www.google.com.uy/', //乌拉
                        'https://www.google.co.uz/', //Uzbekistan
                        'https://www.google.com.vc/', //圣文森特和格林纳丁
                        'https://www.google.co.ve/', //委内瑞拉
                        'https://www.google.vg/', //维京岛
                        'https://www.google.co.vi/', //维尔京群岛
                        'https://www.google.com.vn/', //越南
                        'https://www.google.vu/', //瓦努尔图
                        'https://www.google.ws/', //西萨摩亚
                        //'https://www.google.co.yu/', //南斯拉夫
                        'https://www.google.co.za/', //南非
                        'https://www.google.co.zm/', //赞比亚
                        'https://www.google.co.zw/', //津巴布韦
                    ];
            //随机从数组中获取一个值
            var google_url = googles_url[Math.floor((Math.random()*googles_url.length))];
            need_urls.push(google_url+'search?q='+url_domain+'+email+OR+E-mail+OR+mail+OR+maito+OR+contact+-inurl:(zoominfo|dnb|rocketreach|signalhire|easyleadz|contactout|apollo|verifier|getemail|aeroleads|datanyze)&ie=utf-8&&num=50&oe=utf-8');
            //
            need_urls.push('https://search.yahoo.com/search?p=intext:'+url_domain+'&fr2=sb-top&fr=yfp-t&fp=1');
            //
            need_urls.push('https://search.aol.com/aol/search?q=intext:'+url_domain+'&s_it=sb-top&v_t=na');
            //
            need_urls.push('https://yandex.com/search/?text='+url_domain+'+email&lr=109371');
            var tq = need_urls.length+1;
            domain_tq_set(url, tq, function (){
                //
                util_domains_set_from_html(domain_id, data, 1, need_urls, false);
                //
            });
        }else{
            //
            domain_tq_set(url, 1, function (){
                //
                util_domains_set_from_html(domain_id, '', 1);
                //
            });
            //
        }
    });
}

function spider_request_fetch(domain_id, url, q){
    console.log('spider_request_fetch:'+url);
    let return_html = fetch_request(url);
    return_html.then((data) => {
        if(data){
            util_domains_set_from_html(domain_id, data, q);
        }else{
            //对于访问异常的请求,直接过滤
            util_domains_set_from_html(domain_id, '', q);
        }
    });
}

//监听
chrome.storage.onChanged.addListener(function(changes, namespace) {
    for (var key in changes) {
          var storageChange = changes[key];
          console.log('Storage key "%s" in namespace "%s" changed. ' +
                      'Old value was "%s", new value is "%s".',
                      key,
                      namespace,
                      storageChange.oldValue,
                      storageChange.newValue);
          /*if(key=='domains'){
              var max_bingf = 5;
              var newdomains = storageChange.newValue;
              if(typeof newdomains === 'undefined'){
                  newdomains = storageChange.oldValue;
              }
              console.log('newdomains');
              console.log(newdomains);
              //判断s=1是否有5个，如果有则跳过，如果没有则继续,用来执行同时爬取的网址数
              var s_status_1 = 0;
              for(i=0; i<newdomains.length; i++){
                  if(newdomains[i]['s'] == 1){
                      s_status_1 +=1;
                  }
              }
              if(s_status_1<max_bingf){
                  for(i=0; i<newdomains.length; i++){
                        if(newdomains[i]['s'] == 0){
                            newdomains[i]['s'] = 1;
                            s_status_1 +=1
                            console.log('domain:'+newdomains[i]['d']);
                            spider_domain(i, newdomains[i]['d']);
                            if(s_status_1>=max_bingf){
                                break;
                            }
                        }
                  }
                  //
                  domains_set(newdomains);
                  //
              }
              //
          }*/
    }
    //
    chrome.storage.local.get(null, function(items) {
        console.log('items');
        console.log(items);
    });
    //
 });

function domain_email_set(domain, q=1, emails=[], callback){
    /*chrome.storage.local.set({domains: values}, () => {
        console.log('set successed!');
    });*/
    //q为当前请求第几个，domain
    let prefix = 'dqe_'+$.md5(domain)+"_"+q;
    let obj = {};
    obj[prefix] = emails;
    /*chrome.storage.local.set(obj, () => {
        console.log('domainqemails_:'+domain+' set success');
    });*/
    chrome.storage.local.set(obj, callback);
}

function domain_tq_set(domain, tq=0, callback){
    let prefix = 'dtq_'+$.md5(domain);
    let obj = {};
    obj[prefix] = tq;
    /*chrome.storage.local.set(obj, () => {
        console.log('domain:'+domain+' set success');
    });*/
    chrome.storage.local.set(obj, callback);
}

function domains_set_callback(values, callback){
    /*chrome.storage.sync.set({domains: values}, () => {
        console.log('set successed!');
    });*/
    chrome.storage.local.set({domains: values}, callback);
}

function domains_set(values){
    /*chrome.storage.local.set({domains: values}, () => {
        console.log('set successed!');
    });*/
    chrome.storage.local.set({domains: values}, () => {
        console.log('set successed!');
    });
}

function domains_add(new_domains){
    domains_get(function (callback_data){
        let domains = callback_data['domains'];
        if(typeof domains != 'undefined') {
            for(let i=0;i<new_domains.length;i++){
                let is_exist = false;
                for(let j=0;j<domains.length;j++){
                    if(new_domains[i]['d'] == domains[j]['d']){
                        is_exist = true;
                        break;
                    }
                }
                if(!is_exist){
                    console.log('domains_add:'+new_domains[i]['d']);
                    domains.push(new_domains[i]);
                }
            }
            //
            chrome.storage.local.remove(['domains'],function(){
                var error = chrome.runtime.lastError;
                if (error){console.error(error);}
                else{
                    console.log('domains has remove');
                    domains_set(domains);
                }
            })
            //
        }else{
            domains = new_domains;
            //
            console.log('domains_add domains:'+domains);
            domains_set(domains);
            //
        }
    })
}

function domains_get(callback){
     /*chrome.storage.sync.get('domains', (res) => {
        console.log(res);
        return res;
     });*/
    chrome.storage.local.get('domains', callback);
}

function domains_remove(){
    chrome.storage.local.remove(["domains","key2"],function(){
        var error = chrome.runtime.lastError;
        if (error){console.error(error);}
        else{
            console.log('domains is clean')
        }
    })
}

function domains_remove_keys(keys = []){
    chrome.storage.local.remove(keys,function(){
        var error = chrome.runtime.lastError;
        if (error){console.error(error);}
        else{
            console.log('domains '+keys.join('-')+' has remove');
        }
    })
}

function domains_clear(){
    domains_remove();
    chrome.storage.local.get(null, function(items) {
        for(key in items){
            if(key.indexOf('dtq_') !=-1){
                domains_remove_keys([key])
            }else if(key.indexOf('dqe_') != -1){
                domains_remove_keys([key])
            }
        }
    })
    /*plugin_get_expire(function (callback_data){
        let expire_date = callback_data['expire'];
        if(typeof expire_date != 'undefined'){
            chrome.storage.local.clear(function(){
                console.log('remove all');
                plugin_set_expire(expire_date);
            })
        }else{
            chrome.storage.local.clear(function(){
                console.log('remove all');
            })
        }
    });*/
}

function domains_get_data_process(){
    chrome.storage.local.get(null, function(items) {
        console.log('items');
        //console.log(items);
        //
        let domains = items['domains'];
        if(typeof domains != 'undefined') {
            for(i=0; i<domains.length; i++){
                var _domain = domains[i]['d'];
                //
                var _domain_s = domains[i]['s'];
                if(_domain_s==1){
                    var _domain_dtq_key = 'dtq_'+$.md5(_domain);
                    var _domain_dtq_num = items[_domain_dtq_key];
                    var _domain_dqe_key = 'dqe_'+$.md5(_domain)+'_';
                    var _domain_dqe_num  = 0;
                    for (let _key in items) {
                        console.log('_key:'+_key);
                        if(_key.indexOf(_domain_dqe_key)!=-1){
                            _domain_dqe_num +=1;
                        }
                    }
                    if(_domain_dtq_num == _domain_dqe_num){
                        _domain_s = 2;
                    }
                    if(_domain_s == 2){
                        domains[i]['s'] = 2;
                    }
                    if(_domain_s == 2){
                        //邮箱处理
                        var emails = [];
                        for (let _key in items) {
                            if(_key.indexOf(_domain_dqe_key)!=-1){
                                var _emails = items[_key];
                                if(_emails.length>0){
                                    for(let e=0;e<_emails.length;e++){
                                        if(!emails.includes(_emails[e])){
                                            emails.push(_emails[e]);
                                        }
                                    }
                                }
                            }
                        }
                        //
                         domains[i]['e'] = emails;
                        //
                    }
                    //移除dtq,dqe
                    if(_domain_s == 2){
                        let remove_keys = [];
                        remove_keys.push(_domain_dtq_key);
                        for (let _key in items) {
                            if(_key.indexOf(_domain_dqe_key)!=-1){
                               remove_keys.push(_key);
                            }
                        }
                        //
                        domains_remove_keys(remove_keys);
                        //
                    }
                    //
                }
            }
            //
            domains_set(domains);
            //
        }

    });
}

function xintiao(){
    domains_get(function (callback_data) {
        newdomains = callback_data['domains'];
        //
        var max_bingf = 5;
        console.log('newdomains');
        //console.log(newdomains);
        //判断s=1是否有5个，如果有则跳过，如果没有则继续,用来执行同时爬取的网址数
        if(typeof newdomains != 'undefined') {
            var s_status_1 = 0;
            for (i = 0; i < newdomains.length; i++) {
                if (newdomains[i]['s'] == 0) {
                    newdomains[i]['s'] = 1;
                    s_status_1 += 1
                    console.log('domain:' + newdomains[i]['d']);
                    //spider_domain(i, newdomains[i]['d']);
                    spider_domain_fetch(i, newdomains[i]['d']);
                    if (s_status_1 >= max_bingf) {
                        break;
                    }
                }
            }
            //
            if (s_status_1 > 0) {
                domains_set(newdomains);
            }
        }
        //
    });
}
xintiao();
setInterval(xintiao, 10000);

function plugin_set_expire(expire,callback){
    chrome.storage.local.set({expire: expire}, callback);
}

function plugin_set_active_code(active_code,callback){
    chrome.storage.local.set({active_code: active_code}, callback);
}

function plugin_get_expire(callback){
    chrome.storage.local.get('expire', callback);
}

function google_keyword_set(values, callback){
    chrome.storage.local.set({google_keywords: values},callback);
}

function google_keyword_get(callback){
    chrome.storage.local.get('google_keywords', callback);
}

function google_sns_keyword_set(values, callback){
    chrome.storage.local.set({google_sns_keywords: values}, callback);
}

function google_sns_keyword_get(callback){
    chrome.storage.local.get('google_sns_keywords', callback);
}

function google_shopify_keyword_set(values, callback){
    chrome.storage.local.set({google_shopify_keywords: values}, callback);
}

function google_shopify_keyword_get(callback){
    chrome.storage.local.get('google_shopify_keywords', callback);
}

function test()
{
	alert('我是background！');
}
function storage_get(callback){
    chrome.storage.local.get(null, callback);
}

function pause_switch(callback){
    chrome.storage.local.get(null, function(items) {
        //
        let prefix = 'pause';
        if (!items.hasOwnProperty(prefix)) {
            chrome.storage.local.set({pause: 1}, callback);
        }else{
            if(items[prefix] == 1){
                chrome.storage.local.set({pause: 0}, callback);
            }else{
                chrome.storage.local.set({pause: 1}, callback);
            }
        }
    });
}

function linkedin_companies_clear(){
    chrome.storage.local.get(null, function(items) {
        for(key in items){
            if(key.indexOf('linkedin_companies') !=-1){
                domains_remove_keys([key])
            }else if(key.indexOf('linkedin_company_') != -1){
                domains_remove_keys([key])
            }
        }
    })
}

function storage_remove_keys(keys = []){
    chrome.storage.local.remove(keys,function(){
        var error = chrome.runtime.lastError;
        if (error){console.error(error);}
        else{
            console.log('storage_remove_keys '+keys.join('-')+' has remove');
        }
    })
}

function linkedin_storage_companies_get_data_process(){
    chrome.storage.local.get(null, function(items) {
        let linkedin_companies = items['linkedin_companies'];
        if(typeof linkedin_companies != 'undefined') {
            for(i=0; i<linkedin_companies.length; i++){
                var _id = linkedin_companies[i]['id'];
                var _s = linkedin_companies[i]['s'];
                if(_s == 0 || _s == 1){
                    let _linkedin_company_prefix = 'linkedin_company_'+$.md5(_id);
                    let _linkedin_company = items[_linkedin_company_prefix];
                    if(_linkedin_company){
                        if(_linkedin_company['is_request'] == 2){
                            linkedin_companies[i]['s'] = 2;
                            linkedin_companies[i]['company_website'] = _linkedin_company['url'];
                            //
                            storage_remove_keys([_linkedin_company_prefix])
                            //
                        }else if(_linkedin_company['is_request'] == 1){
                            linkedin_companies[i]['s'] = 1;
                            linkedin_companies[i]['company_website'] = _linkedin_company['url'];
                        }
                    }
                }
                //
            }
            //
            linkedin_storage_companies_set(linkedin_companies);
            //
        }
    });
}

function linkedin_get_company_website_for_url(company_url=''){
    var domain = company_url;
    var _domain = domain.replace('//','');
    var _pos = _domain.indexOf('/');
    if(_pos!=-1){
        var _domain_yichu = _domain.slice(_pos);
        if(_domain_yichu!='/'){
            domain = domain.replace(_domain_yichu, '');
        }
    }
    //
    let exclude_url = [
        'crunchbase',
        'glassdoor',
        'rocketreach',
        'google',
        'linkedin',
        'dnb.com',
        'yelp.com',
        'aliexpress',
        'whitepages',
        'ebay',
        'zoominfo',
        'wikipedia',
        'dnb.com',
        'homedepot',
        'made-in-china',
        'walmart',
        'twitter',
        'ahrefs',
        'alibaba',
        'amazon',
        'china',
        'indeed',
        'indiamart',
        'tiktok',
        'maprequest',
        'fobshanghai',
        'pinterest',
        'apple.com',
        'instagram',
        'yellowpages',
        'medium'
    ];
    for(let i=0; i<exclude_url.length;i++){
        if(domain.indexOf(exclude_url[i]) != -1){
            domain = '';
            break;
        }
    }
    if(domain == '#'){
        return '';
    }
    //
    return domain;
}

function linkedin_storage_companies_set(values){
    /*chrome.storage.local.set({domains: values}, () => {
        console.log('set successed!');
    });*/
    chrome.storage.local.set({linkedin_companies: values}, () => {
        console.log('set successed!');
    });
}

function linkedin_storage_companies_get(callback){
    chrome.storage.local.get('linkedin_companies', callback);
}

function linkedin_storage_companies(linkedin_companies_data=[]){
    //console.log('storage_shangjias_update a');
    chrome.storage.local.get('linkedin_companies', function(items) {
        //console.log('storage_shangjias_update b');
        //console.log(items);
        if(!items.hasOwnProperty('linkedin_companies')){
            let obj = {};
            let linkedin_companies = [];
            for(let i=0;i<linkedin_companies_data.length;i++){
                linkedin_companies.push(linkedin_companies_data[i]);
            }
            obj['linkedin_companies'] = linkedin_companies;
            chrome.storage.local.set(obj);
        }else{
            let storage_linkedin_companies = items['linkedin_companies'];

            for(let i=0;i<linkedin_companies_data.length;i++){
                let is_exists = false;
                for(let j=0;j<storage_linkedin_companies.length;j++){
                    if(linkedin_companies_data[i]['id'] == storage_linkedin_companies[j]['id']){
                        is_exists = true;
                        break;
                    }
                }
                //
                if(!is_exists){
                    storage_linkedin_companies.push(linkedin_companies_data[i]);
                }
                //
            }
            //
            let obj = {};
            obj['linkedin_companies'] = storage_linkedin_companies;
            chrome.storage.local.set(obj);
            //
        }
    })
}

function linkedin_storage_company_set(linkedin_company_data={}, callback){
    let prefix = 'linkedin_company_'+$.md5(linkedin_company_data['id']);
    //
    chrome.storage.local.get(null, function(items) {
        //
        if(!items.hasOwnProperty(prefix)){
            let obj = {};
            obj[prefix] = {
                'id': linkedin_company_data['id'],
                'link': linkedin_company_data['link'],
                'name': linkedin_company_data['name'],
                'is_request':0,
                'url':'',
                'time':0
            };
            chrome.storage.local.set(obj, callback);
        }
        //
    });
    //
}

function linkedin_storage_company_data_set(linkedin_company_id, company_url='', is_request=1, callback){
    let prefix = 'linkedin_company_'+$.md5(linkedin_company_id);
    chrome.storage.local.get(null, function(items) {
        if (items.hasOwnProperty(prefix)) {
            let linkedin_company_data = items[prefix];
            linkedin_company_data['is_request'] = is_request;
            linkedin_company_data['url'] = company_url;
            let obj = {};
            obj[prefix] = linkedin_company_data;
            chrome.storage.local.set(obj, callback);
        }
    });
}

function linkedin_storage_company_data_set_is_request1(linkedin_company_id, callback){
    let prefix = 'linkedin_company_'+$.md5(linkedin_company_id);
    chrome.storage.local.get(null, function(items) {
        if (items.hasOwnProperty(prefix)) {
            let linkedin_company_data = items[prefix];
            linkedin_company_data['is_request'] = 1;
            linkedin_company_data['time'] = Date.now();
            let obj = {};
            obj[prefix] = linkedin_company_data;
            chrome.storage.local.set(obj, callback);
        }
    });
}

function linkedin_storage_company_data_set_is_request0(linkedin_company_id, callback){
    let prefix = 'linkedin_company_'+$.md5(linkedin_company_id);
    chrome.storage.local.get(null, function(items) {
        if (items.hasOwnProperty(prefix)) {
            let linkedin_company_data = items[prefix];
            linkedin_company_data['is_request'] = 0;
            linkedin_company_data['time'] = 0;
            let obj = {};
            obj[prefix] = linkedin_company_data;
            chrome.storage.local.set(obj, callback);
        }
    });
}

function linkedin_spider_company_url_fetch(linkedin_company_id){
    console.log('linkedin_spider_company_url_fetch linkedin_company_id:'+linkedin_company_id);
    //
    chrome.storage.local.get(null, function(items) {
        let prefix = 'linkedin_company_'+$.md5(linkedin_company_id);
        if (items.hasOwnProperty(prefix)) {
            //
            linkedin_storage_company_data_set_is_request1(linkedin_company_id,function (){});
            //
            let linkedin_company_info = items[prefix];
            //
            var googles_url = [
                                'https://www.google.com/', //美国
                                'https://www.google.ca/', //加拿大
                                'https://www.google.cd/', //民主刚果
                                'https://www.google.cg/', //刚果
                                'https://www.google.ch/', //瑞士
                                'https://www.google.ci/', //Cote D’Ivoire
                                'https://www.google.co.ck/', //库克
                                'https://www.google.cl/', //智利
                                'https://www.google.com.co/', //哥伦比
                                'https://www.google.co.cr/', //哥斯达尼加
                                'https://www.google.com.cu/', //古
                                'https://www.google.cz/', //捷克
                                'https://www.google.de/', //德国
                                'https://www.google.dj/', //吉布提
                                'https://www.google.dk/', //丹麦
                                'https://www.google.dm/', //多米尼加联邦
                                'https://www.google.com.do/', //多米尼加共和
                                'https://www.google.com.ec/', //厄瓜多
                                'https://www.google.ee/', //爱沙尼亚
                                'https://www.google.com.eg/', //埃
                                'https://www.google.es/', //西班牙
                                'https://www.google.com.et/', //埃塞俄比
                                'https://www.google.com.fj/', //斐
                                'https://www.google.fm/', //密克罗尼西亚
                                'https://www.google.fr/', //法国
                                'https://www.google.ge/', //格鲁吉亚
                                'https://www.google.gg/', //Guernsey
                                'https://www.google.com.gi/', //Gibraltar
                                'https://www.google.gl/', //格陵兰
                                'https://www.google.gm/',//冈比亚
                                'https://www.google.gp/', //爪德罗普岛
                                'https://www.google.gr/', //希腊
                                'https://www.google.com.gt/', //危地马
                                'https://www.google.gy/', //圭亚那
                                'https://www.google.com.hk/', //香港
                                'https://www.google.hr/', //克罗地亚
                                'https://www.google.ht/', //海地
                                'https://www.google.hu/', //匈牙利
                                'https://www.google.co.id/', //印度尼西亚
                                'https://www.google.ie/', //爱尔兰
                                'https://www.google.co.il/', //以色列
                                'https://www.google.im/', //马恩岛
                                'https://www.google.co.in/', //印度
                                'https://www.google.is/', //冰岛
                                'https://www.google.it/', //意大利
                                'https://www.google.je/', //泽西岛
                                'https://www.google.com.jm/', //牙买
                                'https://www.google.jo/', //约旦
                                'https://www.google.co.jp/', //日本
                                'https://www.google.co.ke/', //肯尼亚
                                'https://www.google.com.kh/', //柬埔
                                'https://www.google.ki/', //基里巴斯
                                'https://www.google.kg/', //吉尔吉斯斯坦
                                'https://www.google.co.kr/', //韩国
                                'https://www.google.kz/', //哈萨克斯坦
                                'https://www.google.la/', //老挝
                                'https://www.google.li/', //列支敦士登
                                'https://www.google.lk/', //斯里兰卡
                                'https://www.google.co.ls/', //莱索托
                                'https://www.google.lt/', //立陶宛
                                'https://www.google.lu/', //卢森堡
                                'https://www.google.lv/', //拉托维亚
                                'https://www.google.com.ly/', //利比
                                'https://www.google.co.ma/', //摩洛哥
                                'https://www.google.md/', //摩尔多瓦
                                'https://www.google.mn/', //蒙古
                                'https://www.google.ms/', //蒙特塞拉特
                                'https://www.google.com.mt/', //马耳
                                'https://www.google.mu/', //毛里求斯
                                'https://www.google.mv/', //马尔代夫
                                'https://www.google.mw/', //马拉维
                                'https://www.google.com.mx/', //墨西
                                'https://www.google.com.na/', //纳米比
                                'https://www.google.com.nf/', //诺夫克
                                'https://www.google.com.ng/', //尼日尼
                                'https://www.google.com.ni/', //尼加拉
                                'https://www.google.nl/', //荷兰
                                'https://www.google.no/', //挪威
                                'https://www.google.com.np/', //尼泊
                                'https://www.google.nr/', //瑙鲁
                                'https://www.google.nu/', //纽埃岛
                                'https://www.google.co.nz/', //新西兰
                                'https://www.google.com.om/', //阿
                                'https://www.google.com.pa/', //巴拿
                                'https://www.google.com.pe/', //秘
                                'https://www.google.com.ph/', //菲律
                                'https://www.google.com.pk/', //巴基斯
                                'https://www.google.pl/',//波兰
                                'https://www.google.pn/', //皮特克恩岛
                                'https://www.google.com.pr/',//波多黎
                                'https://www.google.pt/', //葡萄牙
                                'https://www.google.com.py/', //巴拉
                                'https://www.google.com.qa/', //卡塔
                                'https://www.google.ro/', //罗马尼亚
                                'https://www.google.ru/', //俄罗斯
                                'https://www.google.rw/', //卢旺达
                                'https://www.google.com.sa/', //沙,
                                'https://www.google.com.sb/', //所罗
                                'https://www.google.sc/', //塞舌尔
                                'https://www.google.se/', //瑞典
                                'https://www.google.com.sg/', //新加
                                'https://www.google.sh/', //圣赫勒拿岛
                                'https://www.google.si/', //斯洛文尼亚
                                'https://www.google.sk/', //斯洛伐克
                                'https://www.google.sn/', //塞内加尔
                                'https://www.google.sm/', //圣马力诺
                                'https://www.google.st/', //圣多美和普林西比
                                'https://www.google.com.sv/', //萨尔瓦
                                'https://www.google.co.th/', //泰国
                                'https://www.google.com.tj/', //塔吉克斯
                                'https://www.google.tk/', //托克劳
                                'https://www.google.tm/', //土库曼
                                'https://www.google.to/', //汤加
                                'https://www.google.tp/', //东帝汶
                                'https://www.google.com.tr/', //土耳
                                'https://www.google.tt/', //特立尼和多巴哥
                                'https://www.google.com.tw/', //台
                                'https://www.google.com.ua/', //乌克
                                'https://www.google.co.ug/', //乌干达
                                'https://www.google.co.uk/', //英国
                                'https://www.google.com.uy/', //乌拉
                                'https://www.google.co.uz/', //Uzbekistan
                                'https://www.google.com.vc/', //圣文森特和格林纳丁
                                'https://www.google.co.ve/', //委内瑞拉
                                'https://www.google.vg/', //维京岛
                                'https://www.google.co.vi/', //维尔京群岛
                                'https://www.google.com.vn/', //越南
                                'https://www.google.vu/', //瓦努尔图
                                'https://www.google.ws/', //西萨摩亚
                                //'https://www.google.co.yu/', //南斯拉夫
                                'https://www.google.co.za/', //南非
                                'https://www.google.co.zm/', //赞比亚
                                'https://www.google.co.zw/', //津巴布韦
                            ];
            let google_request_url = googles_url[Math.floor((Math.random()*googles_url.length))];
            let linkedin_company_id_format = linkedin_company_info['id'];
            linkedin_company_id_format = linkedin_company_id_format.replace('-', ' ').replace('linkedin', '');
            google_request_url += 'search?q='+linkedin_company_info['name']+'+OR+'+linkedin_company_id_format+'+-linkedin+-facebook+-youtube+-instagram+-amazon+-twitter'+'&ie=utf-8';
            //
            console.log('linkedin_spider_company_url_fetch google_request_url:'+google_request_url);
            //
            let linkedin_company_link = linkedin_company_info['link'];
            //
            let return_html = fetch_request(google_request_url);
            return_html.then((data) => {
                    if(data){
                        //
                        var $html = $(data);
                        //
                        let linkedin_company_url = '';
                        let _has_record = 0;
                        let _i = 1;
                        $html.find('#res #search .MjjYud').each(function (){
                            let _ahref = $(this).find('a').attr('href');
                            if(_ahref){
                                _has_record = 1;
                            }
                            linkedin_company_url = linkedin_get_company_website_for_url(_ahref);
                            if(linkedin_company_url){
                                return false;
                            }
                            _i++;
                            if(_i > 5){
                                return false;
                            }
                        });
                        //
                        console.log('linkedin_spider_company_url_fetch company url:'+linkedin_company_url);
                        let is_request = 2;
                        //
                        if(_has_record == 0){
                             console.log('_suggestions a1');
                            //没有搜索记录
                            let _suggestions = $html.find('#botstuff .card-section').text();
                            //console.log('_suggestions:'+_suggestions);
                            if(_suggestions){
                                console.log('_suggestions');
                                _has_record = 1;
                            }
                        }
                        //
                        if(_has_record ==0){
                            console.log('_has_record 0');
                            is_request = 1;
                            linkedin_company_url = '请更换翻墙代理或者'+'<a href="'+google_request_url+'" target="_blank">访问该链接自行查看</a>,稍后会自动再采集!';
                        }else{
                            if(linkedin_company_url == ''){
                                linkedin_company_url = '无';
                            }
                        }
                        //
                        linkedin_storage_company_data_set(linkedin_company_id, linkedin_company_url, is_request,function (){
                        });
                    }else{
                        //
                        linkedin_company_url = '请更换翻墙代理或者'+'<a href="'+google_request_url+'" target="_blank">访问该链接自行查看</a>,稍后会自动再采集!';
                        linkedin_storage_company_data_set(linkedin_company_id, linkedin_company_url, 1,function (){
                        });
                        //
                    }
            });
        }
    });
}

function linkedin_xintiao(){

    chrome.storage.local.get(null, function(items) {
        if(items.hasOwnProperty('pause') == false || items['pause'] == 0){
            console.log('linkedin_xintiao items');
            console.log(items);
            var max_bingf = 20;
            let current_max_request = 0;
            for(key in items){
                if(key.indexOf('linkedin_company_') !=-1 && items[key]['is_request'] == 1){
                    current_max_request += 1;
                }
            }
            console.log('linkedin_xintiao current_max_request:'+current_max_request);
            if(current_max_request < max_bingf){
                for(key in items){
                    if(key.indexOf('linkedin_company_') !=-1 && items[key]['is_request'] == 0){
                        //
                        linkedin_spider_company_url_fetch(items[key]['id']);
                        current_max_request++;
                        console.log('linkedin_xintiao current_max_request a2:'+current_max_request);
                        //
                        if(current_max_request >= max_bingf){
                            console.log('linkedin_xintiao current_max_request a3:'+current_max_request);
                            break;
                        }
                    }
                }
            }
            //对于请求后长时间还是is_request=1的请求，重新发起
            for(key in items){
                if(key.indexOf('linkedin_company_') !=-1 && items[key]['is_request'] == 1){
                    let start_time = items[key]['time'];
                    if(start_time < (Date.now()-8000)){
                        linkedin_storage_company_data_set_is_request0(items[key]['id'],function (){});
                        linkedin_spider_company_url_fetch(items[key]['id']);
                        console.log(items[key]['id']+' chaoshi,and chong xin biaoji');
                    }
                }
            }
            //
        }else{
            console.log('linkedin已暂停爬取');
        }
    })

}
linkedin_xintiao();
setInterval(linkedin_xintiao, 10000);

//
function linkedin_company_search_staff_value_set(values, callback){
    chrome.storage.local.set({linkedin_company_search_staff_value: values},callback);
}

function linkedin_company_search_staff_value_get(callback){
    chrome.storage.local.get('linkedin_company_search_staff_value', callback);
}

//linkedin people
function linkedin_storage_people_set(linkedin_people_data={}, callback){
    let prefix = 'linkedin_people_'+$.md5(linkedin_people_data['id']);
    //
    chrome.storage.local.get(null, function(items) {
        //
        if(!items.hasOwnProperty(prefix)){
            let obj = {};
            obj[prefix] = {
                'id': linkedin_people_data['id'],
                '_people_url': linkedin_people_data['_people_url'],
                '_people_name': linkedin_people_data['_people_name'],
                '_people_img': linkedin_people_data['_people_img'],
                '_people_du': linkedin_people_data['_people_du'],
                '_people_position': linkedin_people_data['_people_position'],
                '_people_country': linkedin_people_data['_people_country'],
                '_people_summary': linkedin_people_data['_people_summary'],
                '_people_sales_url':linkedin_people_data['_people_sales_url'],
                '_poeple_mutual_connections':linkedin_people_data['_poeple_mutual_connections'],
                '_is_request':linkedin_people_data['_is_request']
            };
            chrome.storage.local.set(obj, callback);
        }
        //
    });
    //
}

function linkedin_storage_people_update(linkedin_people_data={}, callback){
    let prefix = 'linkedin_people_'+$.md5(linkedin_people_data['id']);
    //
    chrome.storage.local.get(null, function(items) {
        //
        if(items.hasOwnProperty(prefix)){
            let obj = {};
            obj[prefix] = {
                'id': linkedin_people_data['id'],
                '_people_url': linkedin_people_data['_people_url'],
                '_people_name': linkedin_people_data['_people_name'],
                '_people_du': linkedin_people_data['_people_du'],
                '_people_position': linkedin_people_data['_people_position'],
                '_people_country': linkedin_people_data['_people_country'],
                '_people_summary': linkedin_people_data['_people_summary'],
                '_people_sales_url':linkedin_people_data['_people_sales_url'],
                '_poeple_mutual_connections':linkedin_people_data['_poeple_mutual_connections'],
                '_is_request':linkedin_people_data['_is_request']
            };
            chrome.storage.local.set(obj, callback);
        }
        //
    });
    //
}

function linkedin_people_clear(){
    chrome.storage.local.get(null, function(items) {
        for(key in items){
            if(key.indexOf('linkedin_people_') !=-1){
                domains_remove_keys([key])
            }
        }
    })
}

//linkedin kp
function linkedin_storage_kp_set(linkedin_kp_data={}, _num, callback){
    let prefix = 'linkedin_kp_'+$.md5(linkedin_kp_data['id']);
    //
    chrome.storage.local.get(null, function(items) {
        //
         var has_total = 0;
         for (key in items) {
            console.log(key);
            if (key.indexOf('linkedin_kp_') != -1) {
                has_total += 1;
            }
        }
        //
        if(!items.hasOwnProperty(prefix)){
            let obj = {};
            obj[prefix] = {
                'id': linkedin_kp_data['id'],
                '_name': linkedin_kp_data['_name'],
                '_img': linkedin_kp_data['_img'],
                '_linkedin_url': linkedin_kp_data['_linkedin_url'],
                '_position': linkedin_kp_data['_position'],
                '_company_name': linkedin_kp_data['_company_name'],
                '_company_url': linkedin_kp_data['_company_url'],
                '_num':(has_total+_num),
                'is_request':0
            };
            chrome.storage.local.set(obj, callback);
        }
        //
    });
    //
}

function linkedin_kp_task_create(){

}
//end

//监听扩展程序进程或内容脚本发送请求的请求
chrome.runtime.onMessage.addListener(
  function (request, sender, sendResponse) {
    if (request.action == 'linkedin_companies_update') {
        console.log('action',request,sender,sendResponse);
        //
        let linkedin_companies_data = request.info;
        //
        linkedin_storage_companies(linkedin_companies_data);
        //
        for (let i=0;i<linkedin_companies_data.length;i++){
            linkedin_storage_company_set(linkedin_companies_data[i],function (){

            });
        }
        sendResponse({state:'background->content linkedin_companies_update'});
    }else if(request.action == 'linkedin_peoples_update'){ //
        //
        let linkedin_peoples_data = request.info;
        for (let i=0;i<linkedin_peoples_data.length;i++){
            linkedin_storage_people_set(linkedin_peoples_data[i],function (){

            });
        }
        //
    }else if(request.action  == 'linkedin_people_gaoji_get'){
        console.log('linkedin_people_gaoji_get',request,sender,sendResponse);
        chrome.storage.local.get(null, function(items) {
            let need_item = null;
            let has_processed = false;
            for(key in items){
                if(key.indexOf('linkedin_people_') !=-1 && (items[key]['_is_request'] == 1 && items[key]['_s_time'] > (Date.now()-10000) )){
                    has_processed = true;
                    break;
                }
            }
            if(has_processed == false){
                for(key in items){
                    if(key.indexOf('linkedin_people_') !=-1 && (items[key]['_is_request'] == 0 || items[key]['_s_time'] < (Date.now()-10000) )){
                         need_item = items[key];
                         need_item['_is_request'] = 1;
                         need_item['_s_time'] = Date.now();
                         need_item['_status'] = 1;
                         let obj = {};
                         obj[key] = need_item;
                         chrome.storage.local.set(obj, function (){

                         });
                         break;
                    }
                }
            }
            //
            if(need_item){
                sendResponse(JSON.stringify(need_item));
            }else{
                sendResponse(JSON.stringify({'_status':0}));
            }
            //
        });
        //
        return true;
    }else if(request.action == 'linkedin_people_gaoji_update'){
        //
        let linkedin_people_data = request.info;
        linkedin_storage_people_update(linkedin_people_data)
        sendResponse(JSON.stringify({'_status':1}));
        //
    }else if(request.action == 'linkedin_kp_update'){
      //
        let linkedin_kp_datas = request.info;
        for (let i=0;i<linkedin_kp_datas.length;i++){
            linkedin_storage_kp_set(linkedin_kp_datas[i],_num=(i+1), function (){

            });
        }
      //
    }
    //
  }
);

function sendPopTips(msg = '',url=''){
     chrome.runtime.sendMessage({
        action: 'background-tips',
        info: msg,
         url:url,
      }, function (response) {   //接收回调
        console.log(response);  //{state:'关键词填写成功！'}
      });
}

/**
 * 1.
 * chrome.runtime.onInstalled.addListener(details => {
  console.log('previousVersion', details.previousVersion);
});
2.
 //发送消息
 chrome.runtime.sendMessage({
        action: 'send',
        keyword: 'keyword value'
      }, function (response) {   //接收回调
        console.log(response);  //{state:'关键词填写成功！'}
      });

//监听扩展程序进程或内容脚本发送请求的请求
chrome.runtime.onMessage.addListener(
  function (request, sender, sendResponse) {
    if (request.action == 'send') {
      console.log('action',request,sender,sendResponse);
//  request {action: "send", keyword: "keyword value"}
 //sender  {id: "agkllkkjbhclhjnlebdbdagkagfgcecj", url: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj/popup.html", origin: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj"}
//sendResponse  ƒ () { [native code] }
      sendResponse({state:'关键词填写成功！'});
    }
  }
);
 */