function util_get_time(){
    return new Date().getTime() ; // 1622427445085
}

function util_check_expire(expire_date=''){
    if(expire_date==''){
        return true;
    }
    expire_date = expire_date.replace('T00:00:00.000Z','');
    let now_date = new Date();
    expire_date_list = expire_date.split('-');
    expire_date_f = new Date(expire_date_list[0], (expire_date_list[1]-1), expire_date_list[2]);
    if (now_date > expire_date_f) {
        return true;
    }
    return false;
}

function util_url_get_domain(url=''){
    url = url.replace('https://','');
    url = url.replace('http://','');
    url = url.replace('www.','');
    let urlArr = url.split('/');
    if(urlArr.length>0){
        return urlArr[0];
    }
    return '';
}

function util_extract_url(s) {
    //var reg = /(http:\/\/|https:\/\/)((\w|=|\?|\.|\/|&|-)+)/g;
    var reg= /(https?|http|ftp|file):\/\/[-A-Za-z0-9+&@#/%?=~_|!:,.;]+[-A-Za-z0-9+&@#/%=~_|]/g;
    s = s.match(reg);
    console.log(s);
    return(s)
}

function linkedin_companies_caiji(){
    console.log('linkedin_companies_caiji start');
    let linkedin_companies_data = [];
    $('.reusable-search__entity-result-list .reusable-search__result-container').each(function (){
        let linkedin_company_link = $(this).find('.entity-result__title-line a.app-aware-link').attr('href');
        console.log('linkedin_company_link:'+linkedin_company_link);
        let linkedin_company_id = '';
        if(linkedin_company_link){
           linkedin_company_id = linkedin_company_link.replace('https://www.linkedin.com/company/', '').replace('/', '');
        }
        let linkedin_company_name = $(this).find('.entity-result__title-line a.app-aware-link').text();
        if(linkedin_company_name){
            linkedin_company_name = linkedin_company_name.trim();
        }
        let linkedin_company_industry = $(this).find('.entity-result__primary-subtitle').text();
        if(linkedin_company_industry){
            linkedin_company_industry = linkedin_company_industry.trim();
        }
        let linkedin_company_guanzhuzhe = $(this).find('.entity-result__secondary-subtitle').text();
        if(linkedin_company_guanzhuzhe){
            linkedin_company_guanzhuzhe = linkedin_company_guanzhuzhe.trim();
        }
        let linkedin_company_description = $(this).find('.entity-result__summary').text();
        if(linkedin_company_description){
            linkedin_company_description = linkedin_company_description.trim();
        }
        if(linkedin_company_id){
            linkedin_companies_data.push({
                'id': linkedin_company_id,
                'link':linkedin_company_link,
                'name':linkedin_company_name,
                'company_website':'',
                's':0,
                'industry':linkedin_company_industry,
                'guanzhuzhe':linkedin_company_guanzhuzhe,
                'description':linkedin_company_description
            });
        }
    });
    if(linkedin_companies_data.length > 0){
        var message = {
            action: 'linkedin_companies_update',
            info: linkedin_companies_data
        };
        send_message_to_background(message);
        //alert('该页面企业已加入采集!');
    }
}

/***linkedin google people**/
function linkedin_google_people_localStorage(){
    let current_url = window.location.href;
    //
    if(current_url && current_url.indexOf('linkedin.com') != -1) {
        console.log('b');
        var linkedin_infos_localStorage = [];
        if (localStorage.getItem("linkedin_infos_localStorage") == null) {
            localStorage['linkedin_infos_localStorage'] = JSON.stringify([]);
        }
        linkedin_infos_localStorage = JSON.parse(localStorage['linkedin_infos_localStorage']);
        //
        let tj = 0;
        $('#rcnt .MjjYud').each(function () {
            tj = tj + 1;
            console.log('tj:' + tj);
            let _linkedin_url = $(this).find('a').attr('href');
            let _google_title = $(this).find('h3').text();
            _google_title = _google_title.trim();
            if(_google_title.indexOf('linkedin.com/in') == -1 && _google_title){
                //分解姓名、职位、公司
                let _linkedin_people_name = '';
                let _linkedin_people_position = '';
                let _linkedin_people_company = '';
                let _google_title_arr = _google_title.split('–');
                if(_google_title.indexOf('-')!=-1){
                    _google_title_arr = _google_title.split('-');
                }
                if(_google_title_arr.length > 0){
                    _linkedin_people_name = _google_title_arr[0];
                    _linkedin_people_name = _linkedin_people_name.trim();
                    if(_google_title_arr.length > 1){
                        _linkedin_people_position = _google_title_arr[1];
                        _linkedin_people_position = _linkedin_people_position.trim();
                    }
                    if(_google_title_arr.length > 2){
                        _linkedin_people_company = _google_title_arr[2];
                        _linkedin_people_company = _linkedin_people_company.trim();
                    }
                }
                //
                let _google_desc = $(this).find('.VwiC3b').text();
                if (!_google_desc) {
                    _google_desc = $(this).find('.mSA5Bd').text();
                }
                let _google_simple_desc = $(this).find('.MUxGbd').text();
                //
                let is_exists = false;
                for (j = 0; j < linkedin_infos_localStorage.length; j++) {
                    if (linkedin_infos_localStorage[j]['_linkedin_url'] == _linkedin_url) {
                        is_exists = true;
                        break;
                    }
                }
                //
                if (is_exists == false) {
                    linkedin_infos_localStorage.push({
                        '_linkedin_people_name':_linkedin_people_name,
                        '_linkedin_people_position': _linkedin_people_position,
                        '_linkedin_people_company': _linkedin_people_company,
                        '_google_simple_desc': _google_simple_desc,
                        '_linkedin_url': _linkedin_url,
                        '_linkedin_desc': _google_desc
                    })
                }
            }
        });
        //
        console.log('linkedin_infos_localStorage length:' + linkedin_infos_localStorage.length);
        //
        localStorage['linkedin_infos_localStorage'] = JSON.stringify(linkedin_infos_localStorage);
        //
        /*if (current_url.indexOf('search') != -1) {
            let _tips = $("#_gycharm_tips");
            if (!_tips) {
                $("#botstuff div[role='navigation']").append("<div id='_gycharm_tips' style='background-color: #cff4fc;color: #055160;width: 100px;text-align: center;padding:10px 0;margin:0 auto;margin-bottom:10px;margin-top:-15px;'>当前页已采集</div>");
            }
        }*/
    }
    //
}

function linkedin_google_people_export(){
    //
    var shangjia_infos = [];
    //
    var linkedin_infos_localStorage = [];
    if (localStorage.getItem("linkedin_infos_localStorage") == null) {
        localStorage['linkedin_infos_localStorage'] = JSON.stringify([]);
    }
    linkedin_infos_localStorage = JSON.parse(localStorage['linkedin_infos_localStorage']);
    for (let f = 0; f < linkedin_infos_localStorage.length; f++) {
        shangjia_infos.push({
            'Name':linkedin_infos_localStorage[f]['_linkedin_people_name'],
            'Position':linkedin_infos_localStorage[f]['_linkedin_people_position'],
            'Other': linkedin_infos_localStorage[f]['_google_simple_desc'],
            'Company': linkedin_infos_localStorage[f]['_linkedin_people_company'],
            'Url': linkedin_infos_localStorage[f]['_linkedin_url'],
            'Description': linkedin_infos_localStorage[f]['_linkedin_desc']
        });
    }
    //
    linkedin_localStorage_clean();
    //
    var catalog_products = {
         'shangjia_infos': shangjia_infos,
         'file_name': 'gycharm-linkedin-people-'+'-'+util_get_time(),
         'expire':get_expire()
     }
     return catalog_products;
}

function linkedin_localStorage_clean(){
    localStorage.removeItem("linkedin_infos_localStorage");
    localStorage['linkedin_infos_localStorage'] = JSON.stringify([]);
}
/**end**/
/*普通会员people搜索采集*/
function linkedin_people_caiji(){
    console.log('linkedin_people_caiji start');
    let current_url = window.location.href;
    if(current_url && current_url.indexOf('search/results/people') != -1){
        let linkedin_peoples_data = [];
        let row=1;
        $('.reusable-search__entity-result-list .reusable-search__result-container').each(function (){
            //
            let _people_url = $(this).find('.entity-result__title-line a').attr('href');
            console.log('_people_url:'+_people_url);
            if(_people_url && _people_url.indexOf('/in/') != -1){
                console.log('row:'+row);
                console.log(_people_url);
                 let _people_url_arr = _people_url.split('?');
                _people_url = _people_url_arr[0];
                let _people_id = _people_url;
                if(_people_url){
                    let _people_url_arr = _people_url.split("/in/");
                    if(_people_url_arr.length > 1){
                        _people_id = _people_url_arr[1];
                    }
                }
                let _people_name = $(this).find('.entity-result__title-line a span[aria-hidden="true"]').text();
                if(_people_name){
                    _people_name = _people_name.trim();
                }
                let _people_du = $(this).find('.entity-result__badge span[aria-hidden="true"]').text();
                if(_people_du){
                    _people_du = _people_du.replace('•','');
                    _people_du = _people_du.trim();
                }
                let _people_position = $(this).find('.entity-result__primary-subtitle').text();
                if(_people_position){
                    _people_position = _people_position.trim();
                }
                let _people_country = $(this).find('.entity-result__secondary-subtitle').text();
                if(_people_country){
                    _people_country = _people_country.trim();
                }
                let _people_summary = $(this).find('.entity-result__summary').text();
                if(_people_summary){
                    _people_summary = _people_summary.trim();
                }
                //
                let _people_img = '';
                _people_img = $(this).find('img.presence-entity__image').attr('src');
                //
                if(_people_id){
                    linkedin_peoples_data.push({
                        'id': _people_id,
                        '_people_url':_people_url,
                        '_people_name':_people_name,
                        '_people_img':_people_img,
                        '_people_du':_people_du,
                        '_people_position':_people_position,
                        '_people_country':_people_country,
                        '_people_summary':_people_summary,
                        '_people_sales_url':'',
                        '_poeple_mutual_connections':'',
                        '_is_request':2
                    });
                }
                row++;
            }
            //
        });
        if(linkedin_peoples_data.length > 0){
            var message = {
                action: 'linkedin_peoples_update',
                info: linkedin_peoples_data
            };
            send_message_to_background(message);
            //alert('该页面企业已加入采集!');
        }
    }
}

function linkedin_people_insert_iframe_and_get_content(people_item){
    console.log('linkedin_people_insert_iframe_and_get_content');
    let _people_position = people_item['_people_position'];
    if(_people_position.length > 20){
        _people_position_arr = _people_position.split(' ');
        if(_people_position_arr.length > 5){
             let first5Elements = _people_position_arr.slice(0, 5);
            _people_position = first5Elements.join(' ');
        }else{
            _people_position = _people_position_arr.join(' ');
        }
    }
    let _keywords = encodeURI(people_item['_people_name']+' '+_people_position);
    let iframe_url = 'https://www.linkedin.com/search/results/people/?keywords='+_keywords+'&origin=GLOBAL_SEARCH_HEADER&sid=.hK';
    console.log(iframe_url);
    // 创建一个 iframe 元素
    let iframe = document.createElement("iframe");

    // 设置 iframe 的属性
    iframe.src = iframe_url;
    iframe.width = "800";
    iframe.height = "600";
    iframe.frameBorder = "0";  // 去掉边框
    let _iframe_id = 'iframe-gycharm-'+Date.now();
    iframe.id = _iframe_id;
    iframe.style.display = 'none';

    // 将 iframe 插入到特定的容器元素中
    const container = document.body; // 替换为实际容器的 id
    container.appendChild(iframe);
    //
    setTimeout(function() {
         // 假设 iframe 的 id 为 "myIframe"
        console.log('_iframe_id:'+_iframe_id);
        let _iframe = $("#"+_iframe_id);
        // 获取 iframe 内部的文档内容
        let _iframeDocument = _iframe.contents();
        // 获取 iframe 内部文档的 HTML 内容
        let iframeHtml = _iframeDocument.find("html").html();
        //console.log('iframehtml');
        //console.log(iframeHtml);
        //
        let _dom = $(iframeHtml);
        let _people_url = _dom.find('.reusable-search__entity-result-list .reusable-search__result-container:eq(0)')
            .find('.entity-result__title-line a').attr('href');
        console.log('_people_url:'+_people_url);
        if(_people_url && _people_url.indexOf('/in/') != -1) {
            let _people_url_arr = _people_url.split('?');
            _people_url = _people_url_arr[0];
            people_item['_people_url'] = _people_url;
            people_item['_people_url2'] = _people_url;
        }
        people_item['_is_request'] = 2;
        //
        var message = {
            action: 'linkedin_people_gaoji_update',
            info: people_item
        };
        chrome.runtime.sendMessage(message,(msg)=>{
            console.log('linkedin_people_gaoji_update 答复',msg)
        })
        //
        //
       if (iframe) {
          iframe.parentNode.removeChild(iframe);
       }
        //
    }, 8000);
    //
    //
}

/**高级会员采集**/
function util_get_random(){
    // 生成1000到2000之间的随机整数
    // 生成1000到2000之间且是1000的倍数的随机整数
    let min = 40000;
    let max = 80000;
    let randomInteger = Math.floor(Math.random() * ((max / 1000 - min / 1000) + 1)) * 1000 + min;

    console.log('util_get_random:'+randomInteger);
    return randomInteger;

}
function linkedin_people_gaoji_caiji(){
    console.log('linkedin_people_gaoji_caiji start');
    let current_url = window.location.href;
    //&& current_url.indexOf('search/results/people') != -1
    if(current_url){
        let linkedin_peoples_data = [];
        $('.artdeco-list .artdeco-list__item').each(function (){
            console.log('linkedin_people_gaoji_caiji a');
            //
            let _people_sales_url = $(this).find('.artdeco-entity-lockup__title a').attr('href');
            let _people_name = $(this).find("span[data-anonymize='person-name']").text();
            //console.log('_people_name:'+_people_name);
            //console.log('_people_sales_url:'+_people_sales_url);
            if(_people_sales_url && _people_sales_url.indexOf('/sales/lead/') != -1){
                 let _people_sales_url_arr = _people_sales_url.split('?');
                _people_sales_url = _people_sales_url_arr[0];
                let _people_id = _people_sales_url;
                //
                let _people_name = $(this).find("span[data-anonymize='person-name']").text();
                if(_people_name){
                    _people_name = _people_name.trim();
                }
                let _people_du = $(this).find('.artdeco-entity-lockup__degree').text();
                if(_people_du){
                    _people_du = _people_du.replace('·','');
                    _people_du = _people_du.trim();
                }
                let _people_position = $(this).find('.artdeco-entity-lockup__subtitle').text();
                if(_people_position){
                    _people_position = _people_position.trim();
                }
                let _people_country = $(this).find('span[data-anonymize="location"]').text();
                if(_people_country){
                    _people_country = _people_country.trim();
                }
                let _people_summary = $(this).find('dl').text();
                if(_people_summary){
                    _people_summary = _people_summary.trim();
                }
                let _poeple_mutual_connections = $(this).find("button[data-control-name='search_spotlight_second_degree_connection'] span").text();
                if(_poeple_mutual_connections){
                    _poeple_mutual_connections = _poeple_mutual_connections.trim();
                }
                //
                if(_people_id){
                    linkedin_peoples_data.push({
                        'id': _people_id,
                        '_people_url':'',
                        '_people_sales_url':'https://www.linkedin.com'+_people_sales_url,
                        '_people_name':_people_name,
                        '_people_img':'',
                        '_people_du':_people_du,
                        '_people_position':_people_position,
                        '_people_country':_people_country,
                        '_people_summary':_people_summary,
                        '_poeple_mutual_connections':_poeple_mutual_connections,
                        '_is_request':0
                    });
                }
            }
            //
        });
        if(linkedin_peoples_data.length > 0){
            var message = {
                action: 'linkedin_peoples_update',
                info: linkedin_peoples_data
            };
            send_message_to_background(message);
            //alert('该页面企业已加入采集!');
        }
    }
}

function linkedin_people_gaoji_process(){
    util_get_random();
    //
    var message = {
        action: 'linkedin_people_gaoji_get',
        info: ''
    };
    chrome.runtime.sendMessage(message,(msg)=>{
        //console.log('linkedin_people_gaoji_process 答复',msg)
        let msgobj  = JSON.parse(msg);
        //console.log(msgobj);
        if(msgobj['_status'] == 1){
            //
            linkedin_people_insert_iframe_and_get_content(msgobj);
            //
        }
    })
    //
}
linkedin_people_gaoji_process();
setInterval(linkedin_people_gaoji_process, util_get_random());
/*end*/

/*关键人邮箱挖掘*/
function linkedin_kp_caiji(){
    console.log('linkedin_people_gaoji_caiji start');
    let current_url = window.location.href;
    //&& current_url.indexOf('search/results/people') != -1
    if(current_url && current_url.indexOf('company') !=-1 && current_url.indexOf('people') !=-1){
        //
        let linkedin_kp_datas = [];
        let _company_name = $('h1.org-top-card-summary__title').text();
            _company_name = _company_name.trim();
        let _company_url = $('a.org-top-card-primary-actions__action').attr('href');
        if(_company_url){
            _company_url = _company_url.replace('https','').replace('http','').replace('://','').replace('www.','');
            _company_url_arr = _company_url.split('/');
            _company_url = _company_url_arr[0];
        }

        $('.scaffold-finite-scroll__content ul li').each(function (){
            let _name = $(this).find('.artdeco-entity-lockup__title a').text();
            _name = _name.trim();

            let _linkedin_url = $(this).find('.artdeco-entity-lockup__title a').attr('href');
            if(_linkedin_url){
                let _linkedin_url_arr = _linkedin_url.split('?');
                _linkedin_url = _linkedin_url_arr[0];
            }
            let _position = $(this).find('.artdeco-entity-lockup__subtitle').text();
            if(_position.indexOf('at')!=-1){
                let _position_arr = _position.split('at');
                _position = _position_arr[0];
            }
            _position = _position.trim();
            //
            let _img = $(this).find('.artdeco-entity-lockup__image img').attr('src');
            //
            if(_linkedin_url){
                linkedin_kp_datas.push({
                    'id': _linkedin_url,
                    '_name':_name,
                    '_img':_img,
                    '_linkedin_url':_linkedin_url,
                    '_position':_position,
                    '_company_name':_company_name,
                    '_company_url':_company_url
                })
            }
        });
        //
        if(linkedin_kp_datas.length > 0){
            var message = {
                action: 'linkedin_kp_update',
                info: linkedin_kp_datas
            };
            send_message_to_background(message);
        }
        //
    }else if(current_url && current_url.indexOf('/in/') !=-1){
        //
        let linkedin_kp_datas = [];
        let _company_name = $('ul.pv-text-details__right-panel li:eq(0)').text();
            _company_name = _company_name.trim();
        let _company_url = '';

        let _name = $('h1').text();
        _name = _name.trim();

        let _linkedin_url = current_url;
        if(_linkedin_url){
            let _linkedin_url_arr = _linkedin_url.split('?');
            _linkedin_url = _linkedin_url_arr[0];
        }
        let _position = $('.text-body-medium').text();
        if(_position.indexOf('at')!=-1){
            let _position_arr = _position.split('at');
            _position = _position_arr[0];
        }
        _position = _position.trim();
        //
        let _img = $('.pv-top-card-profile-picture__image').attr('src');
        //
        if(_linkedin_url){
            linkedin_kp_datas.push({
                'id': _linkedin_url,
                '_name':_name,
                '_img':_img,
                '_linkedin_url':_linkedin_url,
                '_position':_position,
                '_company_name':_company_name,
                '_company_url':_company_url
            })
        }
        //
        if(linkedin_kp_datas.length > 0){
            var message = {
                action: 'linkedin_kp_update',
                info: linkedin_kp_datas
            };
            send_message_to_background(message);
        }
        //
    }
}
/*end*/

$(document).ready(function(){
  console.log('document on load');
  let current_url = window.location.href;
  if(current_url) {
      if (current_url.indexOf('search/results/companies') != -1) {
          setTimeout(function (){
            linkedin_companies_caiji();
            },3000);
      }
  }
  //linkedin google search
  linkedin_google_people_localStorage();

  //linkedin people
  setTimeout(function (){
    linkedin_people_caiji();
  },2000);

  //linkedin people gaoji
  setTimeout(function (){
    linkedin_people_gaoji_caiji();
  },2000);
  //
  //linkedin kp caiji
  setTimeout(function (){
    linkedin_kp_caiji();
  },2000);
  //
});

function perf_observer(list, obserer){
    //console.log('aa');
    //console.log(getNetworkRequests(list.getEntriesByType('resource')));
    performanceResourceList = list.getEntriesByType('resource');
    //console.log(performanceResourceList);
    for(i = 0; i<performanceResourceList.length; i++){
        performanceResourceItem = performanceResourceList[i];
        //console.log('abababa');
        //console.log(performanceResourceItem);
        if(performanceResourceItem['initiatorType'] == 'xmlhttprequest'){
            if(performanceResourceItem['name'].indexOf('voyager/api/graphql?variables=(start')!=-1){
                //console.log(performanceResourceItem['name']);
                console.log('bbbb'+performanceResourceItem['name']);
                //
                let current_url = window.location.href;
                console.log('current_url:'+current_url);
                if(current_url) {
                    if (current_url.indexOf('search/results/companies') != -1) {
                        setTimeout(function (){
                            linkedin_companies_caiji();
                        },2000);
                    }else if(current_url.indexOf('search/results/people') != -1){
                        setTimeout(function (){
                            linkedin_people_caiji();
                        },2000);
                    }
                    //linkedin kp caiji
                    setTimeout(function (){
                     linkedin_kp_caiji();
                    },2000);
                    //
                }
                //
            }else if(performanceResourceItem['name'].indexOf('search')!=-1){
                //console.log(performanceResourceItem['name']);
                console.log('bbbb'+performanceResourceItem['name']);
                //
                setTimeout(function (){
                    linkedin_google_people_localStorage();
                },2000);
            }else if(performanceResourceItem['name'].indexOf('sales-api/salesApiLeadSearch') != -1 ||
                performanceResourceItem['name'].indexOf('sales-api/salesApiMessagingPresenceStatuses?ids=List') !=-1
            ){
                 //console.log(performanceResourceItem['name']);
                console.log('bbbb'+performanceResourceItem['name']);
                //
                setTimeout(function (){
                    linkedin_people_gaoji_caiji();
                },2000);
            }
        }
    }
    //////
    /*performanceNavigationList = list.getEntriesByType('navigation');
    for(i = 0; i<performanceNavigationList.length; i++) {
        performanceNavigationItem = performanceNavigationList[i];
        if (performanceNavigationItem['initiatorType'] == 'navigation') {
            navigation_url = performanceNavigationItem['name']
        }
    }*/
}
var observer_ = new PerformanceObserver(perf_observer);
//observer_.observe({entryTypes:['resource', 'navigation']});
observer_.observe({entryTypes:['resource', 'navigation', 'paint']});
//

function set_expire(date=''){
    console.log('set_expire:'+date);
    var expire = [];
    if(localStorage.getItem("expire") == null){
        localStorage['expire'] = JSON.stringify([{'expire':''}]);
    }
    localStorage['expire'] = JSON.stringify([{'expire':date}]);

    expire = JSON.parse(localStorage['expire']);
    return expire;
}

function get_expire(){
    if(localStorage.getItem("expire") == null){
        localStorage['expire'] = JSON.stringify([{'expire':''}]);
    }
    expire = JSON.parse(localStorage['expire']);
    return expire;
}

//send message to pop
function send_message_to_popup(message={}){
    /*
    {
            action: 'extract-catalog-products-export-clean',
            info: ''
        }
     */
    console.log('message');
    console.log(message);
    chrome.runtime.sendMessage(message,(msg)=>{
        console.log('答复',msg)
    })
}

//send message to background
function send_message_to_background(message={}){
    /*
    {
            action: 'extract-catalog-products-export-clean',
            info: ''
        }
     */
    console.log('message');
    console.log(message);
    chrome.runtime.sendMessage(message,(msg)=>{
        console.log('答复',msg)
    })
}

// get popup2content info
chrome.runtime.onMessage.addListener((request, sender, sendResponse) => {
    if(request.action == 'linkedin_google_people_export'){
        catalog_products_url = linkedin_google_people_export();
        sendResponse(catalog_products_url);
    }
})